/**
* Filename: StringPreferenceTest.java (in org.openbandy.example.test)
* This file is part of the BandyBasics project.
*
* www.BandyBasics.org
*/

package org.openbandy.example.test;

import org.openbandy.pref.Preferences;
import org.openbandy.service.LogService;
import org.openbandy.test.Test;

/**
 * TODO describe purpose and usage
 *
 * <br><br>
 * (c) Copyright Philipp Bolliger 2007, ALL RIGHTS RESERVED.
 *
 * @author Philipp Bolliger (philipp@bolliger.name)
 * @version 0.1
 * 
 */
public class StringPreferenceTest extends Test {

	public StringPreferenceTest() {
		super("Preferences String");
	}

	public void run() {
		testStarted();
		
		try {
			/* create a new preference */
			Preferences.add("Car Brand", false);
			
			/* set the value to 'Porsche' */
			Preferences.setValue("Car Brand", "Porsche");
			
			/* read the pref value and compare */
			String prefValue = Preferences.getValue("Car Brand");
			if(! prefValue.equals("Porsche")){
				testsScreen.setTestFailed(this);
			}
			
			/* delete the preference */
			Preferences.remove("Car Brand");
			
		} catch (Exception e) {
			LogService.error(this, e.getMessage(), e);
			testsScreen.setTestFailed(this);
		}
        
        
		/* try to read the preference value, must throw exception */
		try{
			Preferences.getValue("Car Brand");
			
			/* if this call didn't throw an exception, the test failed */
			testsScreen.setTestFailed(this);
		}
		catch(Exception upe){
	        testsScreen.setTestPassed(this);
		}
		
		testFinished();
	}

}
