/**
 * Filename: Serializer.java (in org.openbandy.service)
 * This file is part of the BandySerializer project.
 *
 * www.BandySerializer.org
 */

package org.openbandy.service;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;

import org.openbandy.io.Serializable;
import org.openbandy.io.rms.RmsSerializer;
import org.openbandy.io.rms.RmsSerializerImpl;
import org.openbandy.io.stream.StreamSerializer;
import org.openbandy.io.stream.StreamSerializerImpl;

/**
 * TODO describe purpose and usage
 *
 * <br><br>
 * (c) Copyright Philipp Bolliger 2007, ALL RIGHTS RESERVED.
 *
 * @author Philipp Bolliger (philipp@bolliger.name)
 * @version 0.1
 * 
 */
public final class SerializerService extends Service {

	/* create instance of stream serializer that will be used in this service */
	private static StreamSerializer streamSerializer = new StreamSerializerImpl();

	/* if run on microedition , create and instance of rms serializer that will be used in this service */
	private static RmsSerializer rmsSerializer = null;
	static{
		if(runningOnMicroEdition()){
			rmsSerializer= new RmsSerializerImpl();
		}
	}

	/**
	 * TODO comment!
	 *
	 * @param serializable
	 * @param compression
	 * @return
	 */
	public static ByteArrayOutputStream getXmlStream(Serializable serializable, int compression){
		return streamSerializer.getXmlStream(serializable, compression);
	}

	/**
	 * TODO comment!
	 *
	 * @param inputStream
	 * @return
	 */
	public static Serializable getObjectFromXmlStream(ByteArrayInputStream inputStream){
		return streamSerializer.getObjectFromXmlStream(inputStream);
	}

	/**
	 * TODO comment!
	 *
	 * @param serializable
	 */
	public static synchronized void storeToRms(Serializable serializable) {
		if(rmsSerializer != null){
			rmsSerializer.store(serializable);
		}
	}

	/**
	 * TODO comment!
	 *
	 * @param serializable
	 * @param id
	 * @return
	 */
	public static boolean loadFromRms(Serializable serializable, int id) {
		if(rmsSerializer != null){
			return rmsSerializer.load(serializable, id);
		}
		return false;
	}

}
